#include <stdio.h>
#include <stdlib.h>

const int maxN = 500000;
const int maxInt = 32768;

int levi[maxN + 1];
int desni[maxN + 1];
int strana[maxN + 1];
int k1[maxN + 1];
int k2[maxN + 1];
int c1[maxN + 1];
int c2[maxN + 1];
int cvor[maxN + 1];
int moguci[2 * maxN + 1];
int brojac;

void numerisi(int deo) {
     if (deo == -1) return;
     numerisi(levi[deo]);
     brojac++;
     strana[deo] = brojac;
     numerisi(desni[deo]);    
}

// vraca iz [1, k]
int randm(int k) {
    if (k <= maxInt) 
       return (rand() % k + 1);
    return ((rand() * maxInt + rand()) % k + 1);      
}

int main() {
    int index1 = 9;
    char filein[] = "knjizica.xx.in";
    char fileout[] = "knjizica.xx.sol";
    FILE* fin;
    FILE* fout;
    srand(18);
    int T = 10;
    int nn[] = {0, 68, 10000, 50000, 100000, 200000, 220000, 250000, 250000, 250000, 250000};
    int ii, j;
    for (ii = 1; ii <= T; ii++)
    {
        filein[index1] = (ii/10)+'0';
        filein[index1+1] = (ii%10)+'0';
       
        fileout[index1] = (ii/10)+'0';
        fileout[index1+1] = (ii%10)+'0';
       
       
        fin = fopen(filein, "w");
        fout = fopen(fileout, "w");
       
        int n, k, c, lmoguci;
        n = nn[ii]; k = 0; c = 0;
        for (int i = 0; i <= n; i++) {
            levi[i] = -1; desni[i] = -1;
            cvor[i] = i;   
        }
        for (int i = 2; i <= n; i++) {
            j = randm(n - 1) + 1;
            int pom = cvor[i];
            cvor[i] = cvor[j];
            cvor[j] = pom;
        }
        lmoguci = 2; moguci[0] = cvor[1]; moguci[1] = -cvor[1];
        for (int i = 2; i <= n; i++) {
            int pom;
            if (((randm(4) == 1) && (ii == 9)) || ((randm(4) != 1) && (ii == 8)))
                 pom = randm(lmoguci / 2) - 1;
            else 
                 pom = randm(lmoguci) - 1;
            if (moguci[pom] > 0) {
               c1[c] = moguci[pom]; c2[c] = cvor[i]; c++;               
               levi[moguci[pom]] = cvor[i];
            }
            else {
                 k1[k] = -moguci[pom]; k2[k] = cvor[i]; k++;
                 desni[-moguci[pom]] = cvor[i]; 
            }
            moguci[pom] = cvor[i];
            moguci[lmoguci] = -cvor[i];
            lmoguci++;
        }
        fprintf(fin, "%d %d %d\n", n, k, c);
        for (int i = 0; i < k; i++)
            fprintf(fin, "%d %d\n", k1[i], k2[i]);
        for (int i = 0; i < c; i++)
            fprintf(fin, "%d %d\n", c1[i], c2[i]);
            
        brojac = 0;    
        numerisi(1);   
        for (int i = 1; i <= n; i++)
            fprintf(fout, "%d\n", strana[i]);     
            
        fclose(fin);
        fclose(fout);
    }
   
    return 0;  
}
